###################### code to set up the working analysis (delete for ifnal nSolver implementation) 
runanalysis = function(){
  
  # init analysisresults:
  alldata = normresult = QCresult = e = deregresults = DEresults = pathview.results = gsaresults = DEresults.pathscore = CTresult = celltyperesult = celltypescoreslist = pathviewmodule.arg.keggnames = pathviewmodule.arg.keggIDs =  NULL
  
  #setwd("C:/Users/pdanaher/Box Sync/Cancer Immunology Panel")
  source("advanced_analysis_report.r")
  source("advanced_analysis_report_extended2.r")
  source("report writing for IO analyses.r")
  
  # declare where to write the results
  path.results = paste(getwd(),"/results",sep="");dir.create(path.results)
  
  # read the arguments file:
  #cat("loading arguments file",file=log,sep='\n')
  source("source - utils.r")
  source.arguments.and.cast.NULL() #<-------------------------This replaces sourcing arguments.r
  plottypearg = unique(c("png",plottypearg))
  #source("modular code.r")
  source("source - cell type profiling.r")
  source("source - CT antigen.r")
  source("source - DE.r")
  source("source - GSA.r")
  source("source - IO software specific.r")
  source("source - normalization.r")
  source("source - pathview.r")
  source("source - QC.r")
  source("source - SGD.R")
  source("species_specific.r")
  
  
  cat("loaded source",file=log,sep='\n\n',append=TRUE)
  
  #copy static files
  flistcss <- list.files(paste(path.pipeline.base,"//css",sep=""),"^.+[.]css$",full.names=TRUE)
  invisible(file.copy(flistcss,path.css))
  flistjs <- list.files(paste(path.pipeline.base,"//js",sep=""),"^.+[.]js$",full.names=TRUE)
  invisible(file.copy(flistjs,path.js))
  flistimg <- list.files(paste(path.pipeline.base,"//img",sep=""),"^.+[.].+$",full.names=TRUE)
  invisible(file.copy(flistimg,path.img))
  
  # arguments for processing gene annotation: columns of gene annotation file: gene name, HK status, pathway memberships
  
  #####################
  
  #####################
  
  
  
  
  ######################################################
  ####      load/install required libraries         ####
  ######################################################
  resultlib<-suppressWarnings(try(runloadlibraries(), silent = TRUE))
  warnings()
  if(class(resultlib) == "try-error"){
    cat("LOG:could not load libraries",file=log,sep='\n',append=TRUE)
    cat(resultlib,file=log,sep='\n',append=TRUE)
    cat("document.write('<p>Could not load libraries</p>');", file=paste(path.inc,"//status.js",sep=""),append=TRUE)
    stop("could not load libraries")
  }else{
    print("Finished loading R libraries")
    cat("LOG:Finished loading R libraries",file=log,sep='\n\n',append=TRUE)
    cat("document.write('<p>Finished loading R libraries</p>');", file=paste(path.inc,"//status.js",sep=""),append=TRUE) 
  }
  
  ######################################################
  ####      initialize the reporting api         ####
  ######################################################
  initAdvAnalysisReport(path.pipeline.base)
  
  
  ######################################################
  ####    build the panel summarizing the arguments ####
  ######################################################
  arguments.panel = summarize.arguments.file()
  
  
  ######################################################
  #### run the data loading and cleaning function ####
  ######################################################
  if(length(gene.set.column)==0){gene.set.column="Immune.Response.Category"}
  alldata = load.and.clean.data(path.data=path.data,path.sampleannot=path.sampleannot,path.geneannot=path.geneannot,
                                prunegenes.run=prunegenes.run,prunegenes.bg.level=prunegenes.bg.level,
                                prunegenes.missing.freq=prunegenes.missing.freq,
                                min.sample.covariate=min.sample.covariate,
                                gene.annotation.id.column=gene.annotation.id.column,
                                gene.set.column=gene.set.column,
                                sample.annotation.id.column=sample.annotation.id.column,
                                sampleannot.variables=sampleannot.variables,
                                sampleannot.variabletypes=sampleannot.variabletypes,
                                sampleannot.referencelevels=sampleannot.referencelevels,
                                draw.color.legend=TRUE,min.samples=2,min.gene.set.size=5,
                                plottypearg=plottypearg)
  rawdata=alldata$rawdata
  annot=alldata$annot
  gannot=alldata$gannot
  annotcols=alldata$annotcols
  annotcols2=alldata$annotcols2
  sampleannot.variables=alldata$sampleannot.variables
  sampleannot.variabletypes=alldata$sampleannot.variabletypes
  sampleannot.referencelevels=alldata$sampleannot.referencelevels
  gene.set.matrix = alldata$gene.set.matrix
  prune = alldata$prune
  warnings.paragraph=alldata$warnings.paragraph
  #rm(alldata)
  gene.set.matrix.QC = gene.set.matrix
  
  
  ######################################################
  ####            perform normalization             ####
  ######################################################
  
  
  #### normalize data:
  cat("running normalization module",file=log,sep='\n',append=TRUE)
  cat(timestamp(),file=log,sep='\n',append=TRUE)
  if(!normmodule.arg.run){normmodule.arg.method="none"}
  normresult = normalizerawdata(raw=as.matrix(rawdata),method=normmodule.arg.method,
                                choose.method = "geNorm",
                                n.HKs = normmodule.arg.n.HKs,auto.HKs = normmodule.arg.auto.HKs,
                                #codeset.HKs = gannot$is.HK)
                                #codeset.HKs = dimnames(gannot)[[1]][gannot$is.HK==1],
                                codeset.HKs = dimnames(gannot)[[1]][gannot$Class.Name=="Housekeeping"],
                                path.to.normalization.results=path.to.normalization.results,
                                log=log,plottypearg=plottypearg,path.results=path.results,path.inc=path.inc)
  e = normresult$normalized
  
  
  
  
  ######################################################
  ####                 DE analyses                  ####
  ######################################################
  DEmodule.arg.predictors = reconcile.variables.with.annot(annot,variables=DEmodule.arg.predictors,
                                                           variabletypes=NULL,
                                                           referencelevels=NULL)$variables
  if(length(DEmodule.arg.predictors)==0){DEmodule.arg.run=FALSE}
  if(DEmodule.arg.run)
  {
    #gene.set.matrix = gannot[,gene.set.columns]; dimnames(gene.set.matrix)[[1]] = dimnames(gannot)[[1]]
    
    cat("running DE module",file=log,sep='\n\n',append=TRUE)
    cat(timestamp(),file=log,sep='\n',append=TRUE)
    
    
    DEmodule.arg.confounders = reconcile.variables.with.annot(annot,variables=DEmodule.arg.confounders,
                                                              variabletypes=NULL,
                                                              referencelevels=NULL)$variables
    
    cat("predictors:",file=log,sep='\n',append=TRUE)
    suppressMessages(suppressWarnings(write.table(DEmodule.arg.predictors,file=log,sep='\t',append=TRUE)))
    cat("confounders:",file=log,sep='\n',append=TRUE)
    suppressMessages(suppressWarnings(write.table(DEmodule.arg.confounders,file=log,sep='\t',append=TRUE)))
    cat("predictor var types:",file=log,sep='\n',append=TRUE)
    suppressMessages(suppressWarnings(write.table(sampleannot.variabletypes[DEmodule.arg.predictors],file=log,sep='\t',append=TRUE)))
    cat("confounder var types:",file=log,sep='\n',append=TRUE)
    suppressMessages(suppressWarnings(write.table(sampleannot.variabletypes[DEmodule.arg.confounders],file=log,sep='\t',append=TRUE)))
    
    if(length(DEmodule.arg.predictors)>0)
    {
      DEresults = run.DE.analyses(normalized=e[,!prune[colnames(e)],drop=FALSE],predictors=DEmodule.arg.predictors,
                                  confounders=DEmodule.arg.confounders,
                                  annot=annot,
                                  predictor.var.type=sampleannot.variabletypes[DEmodule.arg.predictors],
                                  confounder.var.type=sampleannot.variabletypes[DEmodule.arg.confounders],
                                  sampleannot.referencelevels=sampleannot.referencelevels,
                                  pval.adjustment = DEmodule.arg.pval.adjustment,
                                  gene.sets=gene.set.matrix[!prune[colnames(e)],,drop=FALSE],
                                  path.to.DE.results=path.to.DE.results,
                                  log=log,plottypearg=plottypearg,path.results=path.results,path.inc=path.inc,path.to.csvs=path.to.csvs)
    }  # end if(length(DEmodule.arg.predictors)>0)
    if(DEresults$failed.run)
    {
      DEmodule.arg.run=FALSE
    }
    if(length(DEmodule.arg.predictors)==0)
    {
      warning("No valid predictor variables - DE analysis will not run.")
    }
    
    ## add gene sets corresponding to the DE hits:
    if(!DEresults$failed.run&(length(DEresults$sig.gene.sets)>0))
    {
      for(i in 1:length(DEresults$sig.gene.sets))
      {
        tempcolumn = 1*is.element(rownames(gene.set.matrix),DEresults$sig.gene.sets[[i]])
        gene.set.matrix.QC = cbind(gene.set.matrix.QC,tempcolumn); colnames(gene.set.matrix.QC)[ncol(gene.set.matrix.QC)]=names(DEresults$sig.gene.sets)[i]
      }
    }
  }
  
  
  
  
  
  ######################################################
  ####                  run QC                      ####
  ######################################################
  if(QCmodule.arg.run)
  {
    suppressWarnings(write.table(head(as.data.frame(annot)),file=log,sep='\t',append=TRUE))
    cat("running QC module",file=log,sep='\n',append=TRUE)
    #HTML NOTE - the HTML for the QC is embedded in the other R-file
    cat(timestamp(),file=log,sep='\n',append=TRUE)
    
    QCresult = runQC(normalized=e,HKnormalized=normresult$HKnormalized,HKs=normresult$HKs,
                     covariates=as.data.frame(annot),
                     covariates.type=sampleannot.variabletypes,
                     gene.sets=gene.set.matrix.QC,annotcols=annotcols,annotcols2=annotcols2,codecols=codecols2,
                     path.to.QC.results=path.to.QC.results,
                     log=log,plottypearg=plottypearg,path.results=path.results,path.inc=path.inc,path.to.csvs=path.to.csvs)   
  }
  
  ######################################################
  ####                 pathview                     ####
  ######################################################
  pathviewmodule.arg.local.xml.location = paste(path.pipeline.base,"//KEGG_xml_files",sep="")
  pathviewmodule.arg.keggIDs = c("04660","04662","04650","04612","04151",as.character(pathviewmodule.arg.keggIDs.custom))   #<---------------------- this should probably come from somewhere else.  From the arguments?
  pathviewmodule.arg.keggnames = c("T-Cell receptors","B-cell receptors","NK cytotoxicity","Antigen processing","PI3K-AKT",as.character(pathviewmodule.arg.keggIDs.custom))   #<---------------------- this should probably come from somewhere else.  From the arguments?
  
  if(!DEmodule.arg.run){pathviewmodule.arg.run=FALSE}
  if(!testCon()){
    pathviewmodule.arg.run=FALSE
    warning("No internet connection - Pathview will not be run")
    cat("LOG: Warning: No internet connection - Pathview will not be run",file=log,sep='\n',append=TRUE)
    cat("document.write('<p>Warning: No internet connection - Pathview will not be run</p>');", file=paste(path.inc,"//status.js",sep=""),append=TRUE)
  }
  if(pathviewmodule.arg.run)
  {
    cat("running Pathview module",file=log,sep='\n\n',append=TRUE)
    cat(timestamp(),file=log,sep='\n',append=TRUE)
    # clean the custom IDs to make them parse right: rule: 5 digits, all numbers.
    #<----------------------------------
    
    pathview.results = run.pathview(DEresult=DEresults, 
                                    #keggIDs=c(pathviewmodule.arg.keggIDs,as.character(pathviewmodule.arg.keggIDs.custom)),
                                    keggIDs=pathviewmodule.arg.keggIDs,
                                    colorscheme = pathviewmodule.arg.view.colorscheme,
                                    pvalthresh=pathviewmodule.arg.pvalthres,
                                    view=c("KEGG"),
                                    kegg.dir = pathviewmodule.arg.local.xml.location,
                                    predictors=DEmodule.arg.predictors,path.to.pathview.results=path.to.pathview.results,
                                    log=log,path.results=path.results,path.inc=path.inc,path.to.csvs=path.to.csvs)
    
    setwd(analysis.path)
  }
  
  ######################################################
  ####            gene set analysis                 ####
  ######################################################
  
  if(!DEmodule.arg.run){gsamodule.arg.run=FALSE}
  if(gsamodule.arg.run)
  {
    cat("running gene set analysis module",file=log,sep='\n\n',append=TRUE)
    cat(timestamp(),file=log,sep='\n',append=TRUE)  
    
    gsaresults = run.gene.set.analyses(DEresults,gene.sets=gene.set.matrix[!prune[colnames(e)],,drop=FALSE],
                                       gene.set.names=colnames(gene.set.matrix),
                                       pval.adjustment=DEmodule.arg.pval.adjustment,
                                       log=log,plottypearg=plottypearg,path.results=path.results,path.inc=path.inc,
                                       path.to.csvs=path.to.csvs,path.to.GSA.results=path.to.GSA.results)
  }
  
  
  
  ######################################################
  ####              CT antigen analysis             ####
  ######################################################
  if(sum(gannot$Gene.Class=="CT Antigen",na.rm=T)==0){CT.arg.run=FALSE}
  if(CT.arg.run)
  {
    CTdata = e[,dimnames(gannot)[[1]][!is.na(gannot$Gene.Class)&(gannot$Gene.Class=="CT Antigen")]]
    CTdata.raw = rawdata[,dimnames(gannot)[[1]][!is.na(gannot$Gene.Class)&(gannot$Gene.Class=="CT Antigen")]]
    
    CTresult = CT.antigen.analysis(CTdata,CTdata.raw,CT.arg.backgroundthreshold,
                                   log=log,plottypearg=plottypearg,path.results=path.results,path.inc=path.inc,
                                   path.to.csvs=path.to.csvs,path.to.CT.antigen.results=path.to.CT.antigen.results,
                                   annotcols=annotcols)
  }
  
  ######################################################
  ####               Cell type analysis             ####
  ######################################################
  if(celltypes.arg.run)  #initializing debugging
  {
    # format the covariates:
    if(celltypes.arg.usedefault=="Default"){celltypes.arg.column="Cell.Type.TCGA"; celltypes.arg.geneselection = "UseAllGenes";celltypes.arg.contrastsfile="cell type contrasts matrix.csv"}
    if(length(celltypes.arg.column)==0){celltypes.arg.column="Cell.Type.TCGA"}
    tempcelltype = replace(gannot[,celltypes.arg.column],gannot$Cell.Type=="",NA)
    names(tempcelltype) = dimnames(gannot)[[1]]
    
    #(formerly had covariates = covariates.for.celltypes=annot[,celltypemodule.arg.covariates,drop=FALSE], regardless of whether there were covariates or not.
    # this change may not have been necessary - might make sense to undo it)
    
    if(!exists("celltypes.arg.contrastsfile")){celltypes.arg.contrastsfile="cell type contrasts matrix.csv"}
    celltypecontrasts = read.csv(celltypes.arg.contrastsfile,row.names=1)
    
    celltypes.arg.covariates = reconcile.variables.with.annot(annot,variables=celltypes.arg.covariates,
                                                              variabletypes=NULL,
                                                              referencelevels=NULL)$variables
    
    celltyperesult = immune.cell.abundance.analysis(data = e,celltype = tempcelltype,use.all.genes=(celltypes.arg.geneselection!="DynamicallySelect"),
                                                    lowcor=.2,cell.type.pval.thresh=celltypes.arg.pvalthreshold,
                                                    celltypes.arg.showraw=celltypes.arg.showraw,
                                                    celltypes.arg.showrelative=celltypes.arg.showrelative,
                                                    celltypecontrasts=celltypecontrasts,
                                                    plot.against.covariates=length(celltypes.arg.covariates)>0,
                                                    covariates=annot[,celltypes.arg.covariates,drop=FALSE],
                                                    covariate.type=sampleannot.variabletypes[celltypes.arg.covariates],
                                                    #annotcols=as.matrix(annotcols[,celltypes.arg.covariates]),
                                                    annotcols=annotcols[,celltypes.arg.covariates,drop=FALSE],
                                                    annotcols2=annotcols2[match(celltypes.arg.covariates,dimnames(annot)[[2]])],
                                                    log=log,plottypearg=plottypearg,path.results=path.results,path.inc=path.inc,
                                                    path.to.csvs=path.to.csvs,path.to.celltype.results=path.to.celltype.results)
    celltypescoreslist = celltyperesult$celltypescoreslist
  }
  
  
 
  
  #======================================
  #             SGD analysis
  #======================================
  
  SGD.dir <- NULL
  setwd(analysis.path)
  # if(!single.gene.analysis.run){SGD.dir=NULL}
  if(single.gene.analysis.run){
    
    # SGD  annotation arguments validation
    #-------------------------------------
    SGD.args.in.annots <- c("describe.genes.by","trend.expression.by","order.expression.trend.by","stratify.expression.trend.by")
    for(arg.i in SGD.args.in.annots){
      tmp.annot.names <- get(arg.i)
      
      if(length(tmp.annot.names)<2){
        if(is.null(tmp.annot.names))
          next
        if(is.na(tmp.annot.names))
          next
      }
      
      tmp.annot.renames <- reconcile.variables.with.annot(annot = annot,
                                                          variables = tmp.annot.names,
                                                          variabletypes=NULL,
                                                          referencelevels=NULL)$variables
      assign(arg.i,value = tmp.annot.renames)
      if(length(get(arg.i))==0){
        wtmp <- paste(tmp.annot.names,"is not a valid annotation to",gsub(pattern = "\\.",replacement = " ",x = arg.i),"and is removed from SGD analysis")
        warning(wtmp)
        warnings.paragraph <- paste(warnings.paragraph,"Warning:",wtmp,"\n")
        
        assign(arg.i,value = NULL)
      }
      # Generate warning when annotation contains NA
      else{
        for(annot.name.i in get(arg.i)){
          if(sum(is.na(annot[annot.name.i]))>0){
            wtmp <- paste(annot.name.i," contains NA for some samples! These samples are ignored in SGD when analyzing relative to",annot.name.i)
            warning(wtmp)
            warnings.paragraph <- paste(warnings.paragraph,"Warning:",wtmp,"\n")
          }
        }
      }   
    }
    
    # Trim genes to those left in the dataset after upfront filterings
    #-----------------------------------------------------------------
    gene.names.to.describe <- make.names(gene.names.to.describe)
    if(any(!gene.names.to.describe %in% colnames(e))){
      wtmp <- paste(paste(gene.names.to.describe[!gene.names.to.describe %in% colnames(e)],collapse = ","),"removed in previous analysis steps and will not be included in SGD analysis")
      warning(wtmp)
      warnings.paragraph <- paste(warnings.paragraph,"Warning:",wtmp,"\n")
      gene.names.to.describe <- gene.names.to.describe[gene.names.to.describe %in% colnames(e)]  
    }
    
    # Run if there are any genes to describe
    #---------------------------------------
    if(length(gene.names.to.describe)>0){
      SGD.dir <- tryCatch(expr = {run.SGD.module(normalized.dat = e,
                                                 smp.annots = alldata$annot,
                                                 color.annots = alldata$annotcols,
                                                 color.cat.annots = alldata$annotcols2,
                                                 gene.names.to.describe = gene.names.to.describe,
                                                 describe.genes.by = describe.genes.by,
                                                 stratify.gene.desription.by = NULL,
                                                 trend.expression.by = trend.expression.by,
                                                 order.expression.trend.by = order.expression.trend.by,
                                                 stratify.expression.trend.by = stratify.expression.trend.by,
                                                 file.extension = plottypearg)}
                          , error = function(er){
                            ertmp <- paste("SGD is aborted: the following error occurred in execution of SGD\n",er)
                            cat(ertmp)
                            class(ertmp) <- "SGD.error"
                            return(ertmp)
                          }, finally ={})
      
      # Generate error message if error was caught
      #-------------------------------------------
      if(class(SGD.dir) == "SGD.error"){
        warnings.paragraph <- paste(warnings.paragraph,"Warning:",SGD.dir,"\n")
        SGD.dir <- NULL
      }
      
    }else{
      wtmp <- "No genes remain in the set of genes to describe. Therefore, SGD analysis will not be completed"
      warning(wtmp)
      warnings.paragraph <- paste(warnings.paragraph,"Warning:",wtmp,"\n")
    }
  }# End of SGD run
  
  
  # If SGD aborted set the run arugment to FALSE to not generate report
  #--------------------------------------------------------------------
  if(is.null(SGD.dir))
    single.gene.analysis.run <- FALSE
  
  ######################## 
  #### copy all results to a findable directory:
  cat("making results file directories",file=log,sep='\n\n',append=TRUE)
  # append the date and time to the analysis name for the purpose of copying files:
  advanced.analysis.name.for.file.copy = paste(advanced.analysis.name,gsub(":","-",substr(Sys.time(),1,16)))
  results.copydir = paste(path.results.copy,"//",advanced.analysis.name.for.file.copy,"//",sep="")
  
  # make directories:
  dir.create(results.copydir)
  path.to.normalization.results2 = paste(results.copydir,"Normalization",sep=""); dir.create(path.to.normalization.results2)
  path.to.QC.results2 = paste(results.copydir,"QC",sep=""); dir.create(path.to.QC.results2)
  path.to.pathway.scores2 = paste(results.copydir,"Pathway scoring",sep=""); dir.create(path.to.pathway.scores2)
  path.to.DE.results2 = paste(results.copydir,"DE",sep=""); dir.create(path.to.DE.results2)
  path.to.pathview.results2 = paste(results.copydir,"Pathview",sep=""); dir.create(path.to.pathview.results2)
  path.to.GSA.results2 = paste(results.copydir,"Gene set analysis",sep=""); dir.create(path.to.GSA.results2)
  #path.to.csvs2 = paste(results.copydir,"csvs",sep=""); dir.create(path.to.csvs2)
  path.to.CT.antigen.results2 = paste(results.copydir,"CT antigens",sep=""); dir.create(path.to.CT.antigen.results2)
  path.to.celltype.results2 = paste(results.copydir,"cell types",sep=""); dir.create(path.to.celltype.results2)
  path.to.SGD.results2 = paste(results.copydir,"SGD",sep=""); dir.create(path.to.SGD.results2) 
  
  
  # and copy results:
  # from main results dir:
  cat("copying results files",file=log,sep='\n\n',append=TRUE)
  setwd(path.results)
  tfiles = setdiff(dir(),"csvs")
  for(j in 1:length(tfiles))
  {
    invisible(file.copy(from = tfiles[j],to = paste(results.copydir,tfiles[j],sep="")))
  }
  # from results subdirs:
  if (single.gene.analysis.run) {
    subdirs = c("Normalization","QC","Pathway scoring","DE","Pathview","Gene set analysis","CT antigens","cell types","SGD")
  } else {
    subdirs = c("Normalization","QC","Pathway scoring","DE","Pathview","Gene set analysis","CT antigens","cell types")
  }
  
  for(i in 1:length(subdirs))
  {
    setwd(paste(path.results,"//",subdirs[i],sep=""))
    tfiles = dir()
    for(j in 1:length(tfiles))
    {
      #invisible(file.copy(from = tfiles[j],to = paste(results.copydir,"//",subdirs[i],sep="")))   #<---- 11-7: deleted in favor of the below line by PD.
      invisible(file.copy(from = tfiles[j],to = paste(results.copydir,subdirs[i],sep=""),recursive=TRUE))  
    }
  }
  
  setwd(analysis.path)
  
  # return all analysis results:
  analysisresults = list(alldata = alldata,normresult = normresult,QCresult = QCresult,e = e,deregresults = deregresults,DEresults = DEresults,
                         pathview.results = pathview.results,gsaresults = gsaresults,DEresults.pathscore = DEresults.pathscore,CTresult = CTresult,
                         celltyperesult = celltyperesult,celltypescoreslist = celltypescoreslist,pathviewmodule.arg.keggnames=pathviewmodule.arg.keggnames,
                         pathviewmodule.arg.keggIDs=pathviewmodule.arg.keggIDs,DEmodule.arg.run=DEmodule.arg.run,pathviewmodule.arg.run=pathviewmodule.arg.run,
                         celltypes.arg.run=celltypes.arg.run,gsamodule.arg.run=gsamodule.arg.run,normmodule.arg.run=normmodule.arg.run,CT.arg.run=CT.arg.run,deregmodule.arg.run=deregmodule.arg.run,
                         arguments.panel=arguments.panel,warnings.paragraph=warnings.paragraph,DEmodule.arg.predictors=DEmodule.arg.predictors,DEmodule.arg.confounders=DEmodule.arg.confounders,
                         celltypes.arg.covariates=celltypes.arg.covariates,gene.set.matrix.QC=gene.set.matrix.QC,
                         SGD.dir=SGD.dir, single.gene.analysis.run=single.gene.analysis.run)
  return(analysisresults)
}#end runeverything function
##########################################################################



##########################################################################
## ============>>> Execution Starts Here <<<============================##

## Since we've removed the last page of the wizard (for now?), set this variable here:
deregmodule.arg.run = FALSE

analysis.path = getwd()
log=paste(getwd(),"//log_file.txt",sep="")


#create directory paths
path.resources = paste(getwd(),"//resources",sep="");dir.create(path.resources)
path.js = paste(path.resources,"//js",sep="");dir.create(path.js)
path.css = paste(path.resources,"//css",sep="");dir.create(path.css)
path.img = paste(path.resources,"//img",sep="");dir.create(path.img)
path.inc = paste(path.resources,"//inc",sep="");dir.create(path.inc)
path.results = paste(getwd(),"//results",sep="");dir.create(path.results)

path.to.normalization.results = paste(path.results,"//Normalization",sep=""); dir.create(path.to.normalization.results)
path.to.QC.results = paste(path.results,"//QC",sep=""); dir.create(path.to.QC.results)
path.to.pathway.scores = paste(path.results,"//Pathway scoring",sep=""); dir.create(path.to.pathway.scores)
path.to.DE.results = paste(path.results,"//DE",sep=""); dir.create(path.to.DE.results)
path.to.pathview.results = paste(path.results,"//Pathview",sep=""); dir.create(path.to.pathview.results)
path.to.GSA.results = paste(path.results,"//Gene set analysis",sep=""); dir.create(path.to.GSA.results)
path.to.csvs = paste(path.results,"//csvs",sep=""); dir.create(path.to.csvs)
path.to.CT.antigen.results = paste(path.results,"//CT antigens",sep=""); dir.create(path.to.CT.antigen.results)
path.to.celltype.results = paste(path.results,"//cell types",sep=""); dir.create(path.to.celltype.results)


print("Starting setup")
cat("LOG:Starting setup",file=log,sep='\n')
cat(paste("LOG:Working directory:", analysis.path, sep=""), file=log, sep="\n");

cat("document.write('<p>Starting setup</p>');", file=paste(path.inc,"//status.js",sep=""))


# Run the BIG function
result <- try(runanalysis())
warnings()
if(class(result) == "try-error"){
  print("Analysis could not be completed")
  cat("LOG: Analysis could not be completed",file=log,sep='\n',append=TRUE)
  cat(result,file=log,sep='\n',append=TRUE)
  cat("document.write('<p>Analysis could not be completed</p>');", file=paste(path.inc,"//status.js",sep=""),append=TRUE)
} else {
  ### write the report: 
  reportresult = try(writeIOreport(result))
  warnings()
  if(class(reportresult) == "try-error"){
    print("Failed to write analysis report")
    cat("LOG: Failed to write analysis report",file=log,sep='\n',append=TRUE)
    cat(reportresult,file=log,sep='\n',append=TRUE)
    cat("document.write('<p>Analysis could not be completed</p>');", file=paste(path.inc,"//status.js",sep=""),append=TRUE)
  }
  else {
    print("Analysis is complete")
    cat("LOG:Analysis is complete",file=log,sep='\n',append=TRUE)
    cat("document.write('<p>Analysis is complete</p>');", file=paste(path.inc,"//status.js",sep=""),append=TRUE)
    cat("window.location = \"AdvAnalysisReport.html\";", file=paste(path.inc,"//redirect.js",sep=""),append=TRUE)  
  }
}
setwd(analysis.path)
