
###################################
#### CT antigen analysis        ###
CT.antigen.analysis = function(CTdata,CTdata.raw,CTmodule.background,
                               log,plottypearg,path.results,path.inc,path.to.csvs,path.to.CT.antigen.results,annotcols)
{
  ### first, call detection:
  detected = CTdata.raw>log2(CTmodule.background)
  
  # threshold below so BG doens't look like hits:
  CTdata = replace(CTdata,!detected,1)
  #CTdata = replace(CTdata,CTdata<log2(CTmodule.background),log2(CTmodule.background))
  
  #hmcols<-colorRampPalette(c("white","royalblue","royalblue4"))(256)
  #breaks = c(0,log2(CTmodule.background)+0:4,100)
  linearbreaks = c(100,1000,10000,100000,100000000) 
  breaks = c(0,log2(linearbreaks))
  hmcols<-colorRampPalette(c("white","royalblue4"))(length(breaks)-1)
  for(r in 1:length(plottypearg)){
    plottype=plottypearg[r];
    tempfilename = drawplot(filename=paste(path.to.CT.antigen.results,"//CT antigen heatmap",sep=""),plottype,width=1.5,height=1.75)
    tempfilename=gsub(path.results,"results",tempfilename)
    #heatmap.plus(CTdata,col=hmcols,scale="n",labRow=TRUE,RowSideColors = annotcols,trace="n",density.info="none")
    heatmap.plus(CTdata,col=hmcols,scale="n",RowSideColors = annotcols,breaks=breaks,margins=c(5,10))
    #heatmap.2(CTdata,col=hmcols,scale="n",labRow=TRUE,trace="n",density.info="none")
    dev.off()}
  # and the legend:
  for(r in 1:length(plottypearg)){
    plottype=plottypearg[r];
    tempfilename = drawplot(filename=paste(path.to.CT.antigen.results,"//CT antigen heatmap legend",sep=""),plottype,width=1.5,height=1.75)
    tempfilename=gsub(path.results,"results",tempfilename)
    frame()
    #legend("center",cex=2,lty=1,lwd=12,col=c(hmcols),legend=c(paste("<",round(log2(CTmodule.background),2)),
    #                                                          paste(round(log2(CTmodule.background),2)+0:3,"-",round(log2(CTmodule.background),2)+1:4),
    #                                                          paste(">",round(log2(CTmodule.background),2)+4)))
    legend("center",cex=2,lty=1,lwd=12,col=c(hmcols),legend=c(paste("<",linearbreaks[1]),
                                                              paste(linearbreaks[1:(length(linearbreaks)-2)],"-",linearbreaks[2:(length(linearbreaks)-1)]),
                                                              paste(">",linearbreaks[length(linearbreaks)-1])))
    dev.off()}
  
  return(CTdata)
}

